/*
 * DataAnalyzer.java
 *
 * Created on March 24, 2008, 8:13 PM
 */

package hsbs_gui;

import java.awt.Color;
import java.math.BigDecimal;
import java.sql.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Timer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import net.quies.math.plot.ChartStyle;
import net.quies.math.plot.Function;
import net.quies.math.plot.Graph;
import net.quies.math.plot.InteractiveGraph;
import net.quies.math.plot.LinearTimeIndexScheme;
import net.quies.math.plot.XAxis;
import net.quies.math.plot.YAxis;
/**
 *
 * @author  serdar
 */
public class DataAnalyzer extends javax.swing.JPanel {
    
    /** Creates new form DataAnalyzer */
    public DataAnalyzer() {
        try {
           
           
           
            Calendar cal = Calendar.getInstance();
            java.util.Date now = cal.getTime();
            cal.add(Calendar.YEAR, -50);
            java.util.Date startDate = cal.getTime();
            cal.add(Calendar.YEAR, 100);
            java.util.Date endDate = cal.getTime();
            
            spinModel2 = new SpinnerDateModel(now, startDate, endDate, Calendar.MINUTE);
            cal = Calendar.getInstance();
            cal.add(Calendar.MINUTE,-15);
            java.util.Date now_minus15 = cal.getTime();
            spinModel1 = new SpinnerDateModel(now_minus15, startDate, endDate, Calendar.MINUTE);
          
            
            initComponents();
            
            JSpinner.DateEditor ds= new JSpinner.DateEditor(startSpinner,"dd/MM/yyyy H:mm:ss");
            startSpinner.setEditor(ds);
            
            
            
            JSpinner.DateEditor de= new JSpinner.DateEditor(endSpinner,"dd/MM/yyyy H:mm:ss");
            endSpinner.setEditor(de);
            
            ResultSet rslt1;            
            rslt1 = baglanti.returnQueryResult("SELECT * " + "from Sensors");
            Color a[] = {Color.ORANGE,Color.RED,Color.GREEN,Color.BLUE,Color.CYAN,Color.YELLOW}; 
            int i_color = 0;
            while (rslt1.next()) {
                String nodeName = "Node " + rslt1.getInt("SensorID");
                JCheckBox tmp = new  JCheckBox(nodeName, false);
                checkBoxNodeV.add(tmp);
                humFuncV.add(new Function(nodeName));
                temFuncV.add(new Function(nodeName));
                ChartStyle cstemp = new ChartStyle();
                cstemp.setLowerLimitEnabled(false);
                cstemp.setUpperLimitEnabled(false);
                cstemp.setPaint(a[i_color]);
                if (i_color > 5)
                    i_color=0;
                styleV.add(cstemp);
                //System.out.println(tmp.toString());
                tmp.setVisible(true);
                tmp.addActionListener(new java.awt.event.ActionListener() {
                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                jCheckBoxNodeActionPerformed(evt);
                            }
                        });
                tmp.setForeground(a[i_color]);
                tmp.setBackground(Color.WHITE);
                tmp.setSize(2, 100);
                solMenuPanel.add(tmp);
                i_color++;
            }
            initGraph();
            initFunctions(now_minus15,now);
            initTimer();

            humidityGraphPanel.add(humGraph);
            humidityGraphPanel.setSize(620,400);
            humidityGraphPanel.setVisible(true);
            
            temperatureGraphPanel.add(temGraph);
            temperatureGraphPanel.setSize(620,400);
            temperatureGraphPanel.setVisible(true);
            
            
            
        } catch (SQLException ex) {
            Logger.getLogger(DataAnalyzer.class.getName()).log(Level.SEVERE, null, ex);
        }
    
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        solMenuPanel = new javax.swing.JPanel();
        timePickerPane = new javax.swing.JPanel();
        startLabel = new javax.swing.JLabel();
        endSpinner = new javax.swing.JSpinner(spinModel2);
        endLabel = new javax.swing.JLabel();
        startSpinner = new javax.swing.JSpinner(spinModel1);
        drawButton = new javax.swing.JButton();
        liveDataCheckBox = new javax.swing.JCheckBox();
        graphsTabbedPane = new javax.swing.JTabbedPane();
        humidityGraphPanel = new javax.swing.JPanel();
        temperatureGraphPanel = new javax.swing.JPanel();

        solMenuPanel.setBackground(new java.awt.Color(255, 255, 255));
        solMenuPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        startLabel.setText("From");

        endLabel.setText("To");

        drawButton.setText("Draw");
        drawButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                drawButtonActionPerformed(evt);
            }
        });

        liveDataCheckBox.setText("Live Data");

        org.jdesktop.layout.GroupLayout timePickerPaneLayout = new org.jdesktop.layout.GroupLayout(timePickerPane);
        timePickerPane.setLayout(timePickerPaneLayout);
        timePickerPaneLayout.setHorizontalGroup(
            timePickerPaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(timePickerPaneLayout.createSequentialGroup()
                .add(timePickerPaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(startLabel)
                    .add(startSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(endSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(endLabel)
                    .add(drawButton)
                    .add(liveDataCheckBox))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        timePickerPaneLayout.setVerticalGroup(
            timePickerPaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(timePickerPaneLayout.createSequentialGroup()
                .add(startLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(startSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(endLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(endSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(drawButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 26, Short.MAX_VALUE)
                .add(liveDataCheckBox)
                .addContainerGap())
        );

        humidityGraphPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        humidityGraphPanel.setLayout(new java.awt.BorderLayout());
        graphsTabbedPane.addTab("Humidity", humidityGraphPanel);

        temperatureGraphPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        temperatureGraphPanel.setLayout(new java.awt.BorderLayout());
        graphsTabbedPane.addTab("Temperature", temperatureGraphPanel);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(timePickerPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(solMenuPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 119, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(graphsTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 518, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(graphsTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 370, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(solMenuPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 162, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(timePickerPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void drawButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_drawButtonActionPerformed
        
        
        for (int i = humFuncV.size()-1 ; i >= 0 ;i--){
            humGraph.removeFunction(humFuncV.get(i));        
        }
        humFuncV.removeAllElements();
        for (int i=0; i<solMenuPanel.getComponentCount();i++){
            humFuncV.add(new Function(solMenuPanel.getComponent(i).getName()));
            humGraph.addFunction(humFuncV.get(i), styleV.get(i));
        
        }
        
        for (int i = temFuncV.size()-1 ; i >= 0 ;i--){
            temGraph.removeFunction(temFuncV.get(i));        
        }
        temFuncV.removeAllElements();
        for (int i=0; i<solMenuPanel.getComponentCount();i++){
            temFuncV.add(new Function(solMenuPanel.getComponent(i).getName()));
            temGraph.addFunction(temFuncV.get(i), styleV.get(i));
        
        }
        
        
        initFunctions((java.util.Date)startSpinner.getValue(),(java.util.Date)endSpinner.getValue());
       //System.out.println(spinModel1.getDate().);
       
    }//GEN-LAST:event_drawButtonActionPerformed
    
    
    private void jCheckBoxNodeActionPerformed(java.awt.event.ActionEvent evt) {
        if (!liveDataCheckBox.isSelected())
            drawButtonActionPerformed(evt);
    }
     
    private void initGraph() {
       
        //DateFormat df = DateFormat.getDateTimeInstance();
        
	humGraph.getXAxis().setZigZaginess(BigDecimal.valueOf(9L, 1));
	humGraph.getYAxis().setZigZaginess(BigDecimal.valueOf(9L, 1));
        //graph.getXAxis().getDefaultFormat()= df;
        
	humGraph.setBackground(Color.WHITE);
        
        
        
        temGraph.getXAxis().setZigZaginess(BigDecimal.valueOf(9L, 1));
	temGraph.getYAxis().setZigZaginess(BigDecimal.valueOf(9L, 1));
        //graph.getXAxis().getDefaultFormat()= df;
        
	temGraph.setBackground(Color.WHITE);
        
        
    }
    
    

    private void initFunctions(java.util.Date fromDate, java.util.Date toDate) {
    
        ResultSet rslt;
        String qry;
        
        for (int i=0; i < checkBoxNodeV.size() ;i++){
            if (checkBoxNodeV.get(i).isSelected()){
            try {                        
                humGraph.addFunction(humFuncV.get(i), styleV.get(i));
                qry = "SELECT Hval,UNIX_TIMESTAMP(Humidity.Time) uTime FROM Humidity WHERE SensorID=" + (i+1) + " AND UNIX_TIMESTAMP(Humidity.Time) > " + (fromDate.getTime() / 1000) + " AND UNIX_TIMESTAMP(Humidity.Time) < "+ (toDate.getTime() / 1000 ) + " ORDER BY UNIX_TIMESTAMP(Humidity.Time) ASC ";
                //System.out.println(qry);
                rslt = baglanti.returnQueryResult(qry);

                for (int j = 0; rslt.next(); j++) {
                    BigDecimal y_hum = new BigDecimal( rslt.getFloat("Hval"));
                    BigDecimal x_tim = new BigDecimal(1000*(rslt.getLong("uTime")-timediff));
                    //System.out.println(rslt.getFloat("Hval") + " " + rslt.getLong("uTime")+ " " + x_tim.toPlainString());
                    
                    humFuncV.get(i).addPoint(x_tim, y_hum);
                   
                }
                
                temGraph.addFunction(temFuncV.get(i), styleV.get(i));
                qry = "SELECT Tval,UNIX_TIMESTAMP(Temperature.Time) uTime FROM Temperature WHERE SensorID=" + (i+1) + " AND UNIX_TIMESTAMP(Temperature.Time) > " + (fromDate.getTime() / 1000) + " AND UNIX_TIMESTAMP(Temperature.Time) < "+ (toDate.getTime() / 1000 ) + " ORDER BY UNIX_TIMESTAMP(Temperature.Time) ASC ";
                //System.out.println(qry);
                
                
                rslt = baglanti.returnQueryResult(qry);

                for (int j = 0; rslt.next(); j++) {
                    BigDecimal y_hum = new BigDecimal( rslt.getFloat("Tval"));
                    BigDecimal x_tim = new BigDecimal(1000* (rslt.getLong("uTime")-timediff));
                    //System.out.println(rslt.getFloat("Tval") + " " + rslt.getLong("uTime")+ " " + x_tim.toPlainString());
                    
                    temFuncV.get(i).addPoint(x_tim, y_hum);
                   
                }
                
                
            } catch (SQLException ex) {
                Logger.getLogger(DataAnalyzer.class.getName()).log(Level.SEVERE, null, ex);
            }
            }
        }

    }
    


    private void initTimer() {

        timer.schedule(new TimerTask(){
            public void run(){
                if (liveDataCheckBox.isSelected()){
                  
                    Calendar cal = Calendar.getInstance();
                    java.util.Date now = cal.getTime();
                    
                    cal = Calendar.getInstance();
                    cal.add(Calendar.MINUTE,-2);
                    java.util.Date now_minus1 = cal.getTime();
                    
                    for (int i=0; i<humFuncV.size();i++){
                        humGraph.removeFunction(humFuncV.get(i));        
                    }
                    humFuncV.removeAllElements();
                    for (int i=0; i<solMenuPanel.getComponentCount();i++){
                        humFuncV.add(new Function(solMenuPanel.getComponent(i).getName()));
                        humGraph.addFunction(humFuncV.get(i), styleV.get(i));

                    }
                                       
                    for (int i=0; i<temFuncV.size();i++){
                        temGraph.removeFunction(temFuncV.get(i));        
                    }
                    temFuncV.removeAllElements();
                    for (int i=0; i<solMenuPanel.getComponentCount();i++){
                        temFuncV.add(new Function(solMenuPanel.getComponent(i).getName()));
                        temGraph.addFunction(temFuncV.get(i), styleV.get(i));

                    }
                   
                    initFunctions(now_minus1, now);
                  
                }
            }
        
        
        },200L,2000L);
	timer.schedule(new TimerTask() {

		public void run() {
                    if (graphsTabbedPane.getSelectedIndex() == 0){
			humGraph.render();
			humGraph.repaint();
                    }else if (graphsTabbedPane.getSelectedIndex() == 1){
                        temGraph.render();
                        temGraph.repaint();
                    }
		}

	}, 200L, 1000L);
    }
 
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton drawButton;
    private javax.swing.JLabel endLabel;
    private javax.swing.JSpinner endSpinner;
    private javax.swing.JTabbedPane graphsTabbedPane;
    private javax.swing.JPanel humidityGraphPanel;
    private javax.swing.JCheckBox liveDataCheckBox;
    private javax.swing.JPanel solMenuPanel;
    private javax.swing.JLabel startLabel;
    private javax.swing.JSpinner startSpinner;
    private javax.swing.JPanel temperatureGraphPanel;
    private javax.swing.JPanel timePickerPane;
    // End of variables declaration//GEN-END:variables

    DateFormat myDateFormat = new SimpleDateFormat("dd/MM H:mm:ss");
    
    dbConnection baglanti = new dbConnection();
    Vector <JCheckBox> checkBoxNodeV = new Vector<JCheckBox>();
    private final Timer timer = new Timer("HSBS WSN");
    private final Graph humGraph = new InteractiveGraph(new XAxis("Time of the Record", new LinearTimeIndexScheme(), myDateFormat), new YAxis());
    private final Graph temGraph = new InteractiveGraph(new XAxis("Time of the Record", new LinearTimeIndexScheme(), myDateFormat), new YAxis());
    Vector <Function> temFuncV = new Vector<Function>();
    Vector <Function> humFuncV = new Vector<Function>();
    Vector <ChartStyle> styleV = new Vector<ChartStyle>();
    SpinnerDateModel spinModel1,spinModel2;
    
    static long timediff =  1199232000;
                            
    


}
