/*
 * NodeMonitor.java
 *
 * Created on March 24, 2008, 8:13 PM
 */

package hsbs_gui;

/**
 *
 * @author  serdar
 */
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.io.EOFException;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.InetAddress;
//import java.net.URL;
import java.net.Socket;
import java.net.UnknownHostException;
import java.sql.*;
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreePath;
import javax.swing.ImageIcon;

public class NodeMonitor extends javax.swing.JPanel {
    
    /** Creates new form NodeMonitor */
    
    public NodeMonitor() {
        try {
          ResultSet rslt1, rslt2;

          //Register the JDBC driver for MySQL.
 
          // in an object of type ResultSet
          rslt1 = baglanti1.returnQueryResult("SELECT * " + "from Sensors");
          
          //Use the methods of class ResultSet in a
          // loop to display all of the data in the
          // database.
          //System.out.println("Display all results:");
          while(rslt1.next()){
            SensorTreeNode tmp = new SensorTreeNode("Node " + rslt1.getInt("SensorID"));
            tmp.setLocation(rslt1.getString("Location"));
            tmp.setSensorID(rslt1.getInt("SensorID"));
            String s = rslt1.getString("LastIP");
            //System.out.println(s);
            String[] sip = s.split("\\.",4);
            //System.out.println(sip[0]+"/"+sip[1]+"/"+sip[2]+"/"+sip[3]);
            byte[] b = {Integer.valueOf(sip[0]).byteValue(), Integer.valueOf(sip[1]).byteValue(),
                        Integer.valueOf(sip[2]).byteValue(), Integer.valueOf(sip[3]).byteValue()};
            
            tmp.setSensorIP(b);
            String sQry = "SELECT SensorID sid, COUNT( * ) c "+
                                    "FROM Humidity "+
                                    "WHERE Time > SUBTIME( NOW( ) , '0 0:0:30.000000' ) "+
                                    "AND SensorID="+ tmp.getSensorID() +" GROUP BY sid ";
                                       
            rslt2 = baglanti2.returnQueryResult(sQry);
            
            
            if (rslt2.first()){
                tmp.setActive();}
            else{
                tmp.setInactive();}
            
            root.add(tmp);
          }
         
          //con.close();
        }catch( Exception e ) {
          e.printStackTrace();
        }//end catch
        
        
        initComponents();
        ImageIcon inactiveIcon = new ImageIcon("images/red.jpg");
        ImageIcon activeIcon = new ImageIcon("images/green.jpg");
        
        
        
        if (inactiveIcon != null) {
            nodeTree.setCellRenderer(new MyRenderer(inactiveIcon,activeIcon));
        } else {
            System.err.println("Missing icons");
        }
        
        
        javax.swing.Timer checkTimer = new javax.swing.Timer(5000, new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              checkActivity();
          }
            
        });
        
        checkTimer.start();
       
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        nodeRightClickMenu = new javax.swing.JPopupMenu();
        pingMenuItem = new javax.swing.JMenuItem();
        rebootMenuItem = new javax.swing.JMenuItem();
        leftTreePane = new javax.swing.JScrollPane();
        nodeTree = new javax.swing.JTree(root);
        bottomTextPane = new javax.swing.JScrollPane();
        logTextArea = new javax.swing.JTextArea();
        mapPanel = new javax.swing.JLayeredPane();
        sensor1Label = new javax.swing.JLabel(new ImageIcon("images/redO.gif"));
        sensor2Label = new javax.swing.JLabel(new ImageIcon("images/redO.gif"));

        pingMenuItem.setText("Ping");
        pingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pingMenuItemActionPerformed(evt);
            }
        });
        nodeRightClickMenu.add(pingMenuItem);

        rebootMenuItem.setText("Reboot");
        rebootMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rebootMenuItemActionPerformed(evt);
            }
        });
        nodeRightClickMenu.add(rebootMenuItem);

        nodeTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                nodeTreeMouseReleased(evt);
            }
        });
        leftTreePane.setViewportView(nodeTree);

        logTextArea.setColumns(20);
        logTextArea.setRows(5);
        bottomTextPane.setViewportView(logTextArea);

        ImageIcon image = new ImageIcon("images/desks.gif");
        JLabel background = new JLabel(image);
        background.setBounds(0, 0, image.getIconWidth(), image.getIconHeight());
        mapPanel.add(background,mapPanel.DEFAULT_LAYER);

        sensor1Label.setText("1");
        sensor1Label.setBounds(80, 30, 80, 60);
        mapPanel.add(sensor1Label, javax.swing.JLayeredPane.POPUP_LAYER);

        sensor2Label.setText("2");
        sensor2Label.setBounds(90, 220, 80, 60);
        mapPanel.add(sensor2Label, javax.swing.JLayeredPane.POPUP_LAYER);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, bottomTextPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 411, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(leftTreePane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 152, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(mapPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(mapPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 284, Short.MAX_VALUE)
                    .add(leftTreePane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 284, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(bottomTextPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 85, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void nodeTreeMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_nodeTreeMouseReleased
        // TODO add your handling code here:
        if (evt.getButton()== MouseEvent.BUTTON3){
        //if (evt.isPopupTrigger()){
            p = evt.getPoint();
            nodeRightClickMenu.show(nodeTree, p.x, p.y);
            //System.out.println(p.x+" "+p.y);
            tpath = nodeTree.getPathForLocation(p.x,p.y);
            nodeTree.setSelectionPath(tpath);
        }
    }//GEN-LAST:event_nodeTreeMouseReleased
    
    private void checkActivity() {
        try {
          
          ResultSet rslt;

          
      
          for (int i=1;i <= root.getChildCount();i++){
      
            String sQry = "SELECT SensorID sid, COUNT( * ) c "+
                                    "FROM Humidity "+
                                    "WHERE Time > SUBTIME( NOW( ) , '0 0:0:5.000000' ) "+
                                    "AND SensorID="+ i +" GROUP BY sid ";
                    
            SensorTreeNode tmp = (SensorTreeNode)root.getChildAt(i-1);
                    
            rslt = baglanti1.returnQueryResult(sQry);
            
            //System.out.println(sQry);
            ImageIcon act = new ImageIcon("images/greenO.gif");
            ImageIcon inact = new ImageIcon("images/redO.gif");
            
            if (rslt.first()){
                tmp.setActive();
                if (i == 1)
                    sensor1Label.setIcon(act);
                else if(i == 2)
                    sensor2Label.setIcon(act);
                }
            else{
                tmp.setInactive();
                if (i == 1)
                    sensor1Label.setIcon(inact);
                else if(i == 2)
                    sensor2Label.setIcon(inact);
            
            }
            
            Graphics nodeGraph = leftTreePane.getParent().getGraphics();
            paintAll(nodeGraph);
            
            nodeRightClickMenu.repaint();
            
          }
          
          //con.close();
        }catch( Exception e ) {
          e.printStackTrace();
        }
        
        
        
        
        
    }
    
    private void pingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pingMenuItemActionPerformed
        // TODO add your handling code here:
       
        SensorTreeNode tmp = (SensorTreeNode) tpath.getLastPathComponent();
       // System.out.println(nodeRightClickMenu.getX()+" "+nodeRightClickMenu.getY());
        System.out.println(tmp.getLocation());
        
        String s;
        try {

            PingTimer t = new PingTimer();

            InetAddress address = InetAddress.getByAddress(tmp.getSensorIP());

            s = "Node IP: " + address.getHostAddress() + "\n";       
            t.start();
            s = s + "Reachable: " + address.isReachable(5000) + "\n";
            t.end();
            s = s + "Took: "+ (t.duration()/1000000.0) + "ms\n";
            s = s + "Location: " + (tmp.getLocation()) + "\n";
        }
        catch (UnknownHostException e) {
            s = "Coudn't get route to host\n";
        }
        catch (IOException e) {
            s = "Host doesn't responding\n";
        }
        
        logTextArea.append(s);
        
        
        
        
        
    }//GEN-LAST:event_pingMenuItemActionPerformed

    private void rebootMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rebootMenuItemActionPerformed
        // TODO add your handling code here:
        Socket s = null;
        SensorTreeNode tmp = (SensorTreeNode) tpath.getLastPathComponent();
 	try
 
 	{
 
 		int serverPort = 2001;
                InetAddress address = InetAddress.getByAddress(tmp.getSensorIP());
                
 		s = new Socket(address, serverPort);

 		PrintWriter out = new PrintWriter(s.getOutputStream(), true);
                
                out.write("12345");
                out.close();

       	}
 	catch (UnknownHostException e)
 	{
 		System.out.println("Sock:"+e.getMessage());
        }
 	catch (EOFException e)
 	{
 		System.out.println("EOF:"+e.getMessage());
 	}
 	catch (IOException e)
 	{
 		System.out.println("IO:"+e.getMessage());
 	}
 	finally
 	{
 		if(s!=null)
 			try
 			{
 				s.close();
 			}
 			catch (IOException e)
 			{
 				System.out.println("close:"+e.getMessage());
 			}
 	}    
        
     
    }//GEN-LAST:event_rebootMenuItemActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane bottomTextPane;
    private DefaultMutableTreeNode root = new DefaultMutableTreeNode();
    private javax.swing.JScrollPane leftTreePane;
    private javax.swing.JTextArea logTextArea;
    private javax.swing.JLayeredPane mapPanel;
    private javax.swing.JPopupMenu nodeRightClickMenu;
    private javax.swing.JTree nodeTree;
    private javax.swing.JMenuItem pingMenuItem;
    private javax.swing.JMenuItem rebootMenuItem;
    private javax.swing.JLabel sensor1Label;
    private javax.swing.JLabel sensor2Label;
    // End of variables declaration//GEN-END:variables
    private Point p;
    private TreePath tpath;
    dbConnection baglanti1 = new dbConnection();
    dbConnection baglanti2 = new dbConnection();
    Connection con;

    
    
    
    
    private class MyRenderer extends DefaultTreeCellRenderer {
        Icon activeIcon;
        Icon inactiveIcon;

        public MyRenderer(Icon inact,Icon act) {
            activeIcon = act;
            inactiveIcon = inact;
            
        }

        @Override
        public Component getTreeCellRendererComponent(
                            JTree tree,
                            Object value,
                            boolean sel,
                            boolean expanded,
                            boolean leaf,
                            int row,
                            boolean hasFocus) {

            super.getTreeCellRendererComponent(
                            tree, value, sel,
                            expanded, leaf, row,
                            hasFocus);
            if (leaf){
            if (isActiveNode(value))    
                setIcon(activeIcon);
            else 
                setIcon(inactiveIcon);
            
            }
            return this;
        }
        
        protected boolean isActiveNode(Object value) {
            SensorTreeNode node =
                    (SensorTreeNode)value;
            
            return node.isActive();
            
            
        }

        
    }    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}
